      $SET db2(db=db2demo) charset(ebcdic)
      *---------------------------------------------------------------
      *--- Copyright (C) 1992-2006 Micro Focus International Ltd.
      *--- All rights reserved.
      *---------------------------------------------------------------
      *--- Dynamic SQL example - fixed-list SELECT
      *---------------------------------------------------------------
       IDENTIFICATION DIVISION.
       PROGRAM-ID.    HCODYN1.

       DATA DIVISION.
       WORKING-STORAGE SECTION.

       01  PRODUCT-LINE.
           05 FILLER                   PIC X(010) VALUE
              'Product = '.
           05 DISPLAY-ID               PIC X(004) VALUE ' '.
           05 FILLER                   PIC X(010) VALUE
              '   Desc = '.
           05 DISPLAY-DESC             PIC X(035) VALUE ' '.
           05 FILLER                   PIC X(007) VALUE
              ' Amt = '.
           05 DISPLAY-AMT              PIC $,$$$,$$9.99.

      *--- Please note: VARCHARS must use host variable with
      *--- level 49's if a length component is used

       01  WS-SELECT.
           49 WS-SELECT-IX             PIC S9(04) COMP.
           49 WS-SELECT-DATA           PIC X(1500).

       01  IX                          PIC S9(04) COMP.
       01  ERR-REC-LTH                 PIC S9(09) COMP.
       01  ERR-MSG-AREA.
           05 ERR-MSG-LTH              PIC S9(04) COMP.
           05 ERR-MSG-TEXT             PIC X(700).
           05 ERR-MSG-TBL    REDEFINES ERR-MSG-TEXT.
              10 ERR-TEXT              PIC X(070) OCCURS 10 TIMES.

       01  WS-DATE                     PIC X(010).
           EXEC SQL INCLUDE SQLCA      END-EXEC.
           EXEC SQL INCLUDE PRODUCT    END-EXEC.

      *---------------------------------------------------------------
      *--- Dynamic SQL example - fixed-list SELECT
      *---------------------------------------------------------------

       PROCEDURE DIVISION.

       0000-MAIN-LOGIC.

           DISPLAY 'BEG HCODYN1 TEST'

           EXEC SQL
                CONNECT TO DB2DEMO
           END-EXEC

      *--- Demonstrate a fixed-list SELECT

           MOVE 1                      TO WS-SELECT-IX
           MOVE SPACES                 TO WS-SELECT-DATA

           STRING 'SELECT PROD_ID,PROD_DESC,AMT_EACH' DELIMITED BY SIZE
                  ' FROM DEMO.PRODUCT'                DELIMITED BY SIZE
                  ' ORDER BY PROD_ID, PROD_DESC'      DELIMITED BY SIZE
             INTO WS-SELECT-DATA
             WITH POINTER WS-SELECT-IX
           END-STRING

      *--- HCO will automatically convert dashes in cursor
      *--- and dynamic SQL names to underscores
      *--- sinces dashes in these names are supported in DB2 UDB V5
      *--- or earlier

           EXEC SQL
                DECLARE CSR-01 CURSOR FOR DYNAM-CSR01
           END-EXEC

           EXEC SQL
                PREPARE DYNAM-CSR01 FROM :WS-SELECT
           END-EXEC

           IF SQLCODE NOT = 0
               PERFORM 9999-SQL-ERR  THRU 9999-EXIT
           END-IF

           EXEC SQL
                OPEN CSR-01
           END-EXEC

           IF SQLCODE NOT = 0
               PERFORM 9999-SQL-ERR  THRU 9999-EXIT
           END-IF

           PERFORM 2000-FETCH-CSR    THRU 2000-EXIT
             UNTIL SQLCODE NOT = 0

           EXEC SQL
                CLOSE CSR-01
           END-EXEC

           DISPLAY 'END HCODYN1 TEST'

      *--- Call the routine to demonstrate varying-list SELECT

           CALL 'HCODYN2'           USING WS-DATE
                                          SQLCA
                                          DCLPRODUCT

           GOBACK.

      *---------------------------------------------------------------
      *--- Get data from table
      *---------------------------------------------------------------

       2000-FETCH-CSR.

           MOVE SPACES                 TO PRD-PROD-DESC-TEXT

           EXEC SQL
                FETCH CSR-01
                 INTO :PRD-PROD-ID
                     ,:PRD-PROD-DESC
                     ,:PRD-AMT-EACH
           END-EXEC

           IF SQLCODE = 0
               MOVE PRD-PROD-ID        TO DISPLAY-ID
               MOVE PRD-PROD-DESC-text TO DISPLAY-DESC
               MOVE PRD-AMT-EACH       TO DISPLAY-AMT
               DISPLAY PRODUCT-LINE
           ELSE
               IF SQLCODE NOT = +100
                   PERFORM 9999-SQL-ERR THRU 9999-EXIT
               END-IF
           END-IF.

       2000-EXIT.
           EXIT.

      *---------------------------------------------------------------
      *--- Call DSNTIAR to get SQL Error Message text
      *---------------------------------------------------------------

       9999-SQL-ERR.

           MOVE 70                     TO ERR-REC-LTH
           MOVE 700                    TO ERR-MSG-LTH

           CALL 'DSNTIAR'           USING SQLCA
                                          ERR-MSG-AREA
                                          ERR-REC-LTH

           PERFORM VARYING IX FROM 1 BY 1 UNTIL IX > 10
               DISPLAY ERR-TEXT (IX)
           END-PERFORM.

       9999-EXIT.
           EXIT.
